local component = require('component')
local computer = require('computer')

local D = loadfile('me_processor_lib/debug.lua')()

function processor_craft.assembler(machine, processor, recipe, amount, status_prefix, slot_count, reserved_slots, slot_map)
  local assembler = component.getPrimary("assembler")
  assembler.start()
  os.sleep(0.1)
  
  while assembler.status() == "busy" do
    print("Assembling...")
    os.sleep(1)
  end

  -- Make room.
  processor.transposer:cancel_request(reserved_slots[1])

  -- And move.
  processor.transposer:move(processor.side, 1, reserved_slots[1].side, reserved_slots[1].slot, 1)

  print("Assembling done.")

  return 1
end

function processor_init.crafter(machine)
  -- FIXME: Enable robots and add sticks if needed.
end
