-- Mostly a straight copy of generic thread. Code duplication bad. Fix?

local component = require('component')
local computer = require('computer')

local D = loadfile('me_processor_lib/debug.lua')()

local database = component.getPrimary("database")
local me_interface = component.getPrimary("me_interface")

local export_slot = 0

function processor_craft.crafter(machine, processor, recipe, amount, status_prefix, slot_count, reserved_slots, slot_map)
  local max_size = 64  -- FIXME: Obviously not.

  if amount > max_size then
    amount = max_size
  end

  for n = 1, slot_count do
    if not processor.transposer:wait_for_request(reserved_slots[n], amount, 1) then
      print("Timeout while waiting for " .. amount .. " of " .. database.get(reserved_slots[n].database_slot).label .. ".")
      return false
    else
      processor.transposer:move(reserved_slots[n].side, reserved_slots[n].slot, processor.side, machine.slot_map[slot_map[n]], amount)
    end
  end

  -- Move stick.
  if processor.transposer:move(processor.side, 4, processor.side, 8, 1) ~= 1 then    -- 1 Tick.
    print("Crafting stick is not where it should be.")
    return false
  end

  if export_slot == 0 then
    local tries = 0
      
    while processor.transposer:count(processor.side, 15) == 0 and processor.transposer:count(processor.side, 16) == 0 and tries <= 10 do
      os.sleep(0.1)
      tries = tries + 1
    end
      
    if tries > 10 then
      print("Could not figure out export slot.")
      os.exit()
    end

    if processor.transposer:count(processor.side, 15) ~= 0 and processor.transposer:count(processor.side, 16) ~= 0 then
      print("Both crafter export slots have items.")
      return false
    end

    if processor.transposer:count(processor.side, 15) ~= 0 then
      export_slot = 15
    else
      export_slot = 16
    end
  end

  local moved = 0
  local tries = 0
  repeat
    moved = processor.transposer:move(processor.side, export_slot, processor.transposer.chest[1].side, 1, 64)    -- 1 Tick.
    if moved == 0 then
      os.sleep(0.1)    -- 2 Ticks
      tries = tries + 1
    end
  until this_move ~= 0 or tries > 10

  export_slot = (export_slot == 15 and 16 or 15)

  print(status_prefix .. " (" .. moved .. ").")

  if tries > 10 then
    print("tried 10 times and failed.")
    return false
  end

  -- Yield
  os.sleep(0)

  return moved
end

function processor_init.crafter(machine)
  -- FIXME: Enable robots and add sticks if needed.
end
